#ifndef EDIT_HH
#define EDIT_HH 1

#include <string>
#include <SliceData.hh>
#include <Foundation.hh>

using libSlice::SliceData;

class Edit
{
public: 
  
  Edit(const string & contigId,
       long gindex,
       long index,
       long seqPos,
       const string & seqName,
       char origBase,
       char editBase,
       int rc,
       int newQV,
       LogCategory log,
       int editFilterLevel);

  ~Edit();

  void printXML(ostream & out, const string & prefix="");
  int  apply(SliceData * slice, long seqpos);
  int  seqOffset();

  void setVerifyIndex(bool verifyIndex);

  const string & getSeqname() const;

private:

  LogCategory m_log;

  string m_contigId;
  long   m_gindex;
  long   m_index;
  long   m_seqPos;
  string m_seqName;
  char   m_origBase;
  char   m_editBase;
  int    m_rc;
  int    m_qv;
  int    m_editFilterLevel;

  bool   m_verifyIndex;
};

#endif
