#ifndef CONTIG_ALIGN_HH
#define CONTIG_ALIGN_HH 1

#include "Contig.hh"

#include <vector>
typedef vector<long int> DeltaVector;


class ContigAlign
{
public:
  ContigAlign::ContigAlign(bool verbose);
  virtual ContigAlign::~ContigAlign();


  virtual int fattenLeft(Contig * contig,
                         ContigSequence * read,
                         int distance) = 0;

  virtual int fattenRight(Contig * contig,
                          ContigSequence * read,
                          int distance) = 0;

protected:
  void initializePublicAPI(Contig * contig);

  Contig * m_contig;
  long m_gindex;

  long int getBasesToSkip(DeltaVector & delta,
                          DeltaVector::const_iterator & deltaiter,
                          bool & consGap,
                          unsigned int cpos,
                          unsigned int rpos,
                          const string & trimmed,
                          const string & consensus,
                          bool autoPromoteConsGaps);

  void mergeExtension(unsigned int & cpos, 
                      unsigned int & lastConsPos,
                      unsigned int & rpos, 
                      string & trimmedSeq, 
                      string & consensus,
                      ContigSequence * read,
                      DeltaVector & delta,
                      bool autoPromoteConsGaps,
                      int consMovementDelta);

  bool m_verbose;
};


#endif
