#ifndef TILINGMANAGER_HH
#define TILINGMANAGER_HH 1

#include "SequenceData.hh"
#include "ConsensusSequence.hh"
#include "RequestManager.hh"

#include <list>

using libSlice::SliceData;

typedef list<ConsensusSequence *> ConsensusSequenceList;

class TilingManager : public RequestManager
{
public:
  TilingManager();
  ~TilingManager();

  void addRequest(ConsensusRequest * requestData);
  void addSliceRange(long & index, long & gindex);
  void addSlice(SliceData * slice);

  int  printResults();

private:
  void printHeader();

  ConsensusRequest * m_requestData;
  ConsensusSequence * m_consensusSequence;
  ConsensusSequenceList m_consensusSequenceList;

  int m_contigCount;
};

#endif
